
basic = require("lib.basic")
hash = require("lib.hash")
--aes = require("lib.aes") --aes does not yet work with require
os.loadAPI("brulijam/lib/aes.lua")

function createKeyfile()
  basic.clearDisplay()
  print("[NETWORKING]")
  write("Please enter shared secret for networking: ")
  local pwHash = hash.digestStr(read("*") .. "salty salt")
  basic.writeToFile("brulijam/config/networking-key.txt", pwHash)
  basic.clearDisplay()
end

local function getKeyfile()
  local pwHash = basic.readFileOneline("brulijam/config/networking-key.txt")
  return pwHash
end

local function setup()
  ownLabel = os.computerLabel()
  peripheral.find("modem", rednet.open)
  if not fs.exists "brulijam/config/networking-key.txt" then
    --createKeyfile()
    shell.run("/brulijam/lib/createNetworkingKey.lua")
  end
end

--[[
String target ist label des Computers. zb "computer1", "miner1", "farmer1", etc
String message ist einfach der Text der Übertragen werden soll
]]
function sendMessage(to, what, payload)
  setup()
  local keyfile = getKeyfile()
  local msgTable = {}
  msgTable[0] = ownLabel
  msgTable[1] = to
  msgTable[2] = what
  msgTable[3] = payload

  local encMsg = aes.encrypt(keyfile, textutils.serialize(msgTable))
  rednet.broadcast(encMsg)
end

function sendLog(to, targetPath, logMsg)
  setup()
  local keyfile = getKeyfile()
  local payloadTable = {}

  payloadTable[0] = targetPath
  payloadTable[1] = "[" .. basic.getCurrentTime() .. "]: " .. logMsg

  sendMessage(to, "log", payloadTable)
  basic.ntfy("[" .. os.getComputerLabel() .. "] " .. payloadTable[1])
end

function sendFile(to, originPath, targetPath)
  setup()
  local keyfile = getKeyfile()
  local payloadTable = {}

  print("sending " .. originPath .. " to " .. to)

  local fileContent = basic.readFileAll(originPath)
  payloadTable[0] = targetPath
  payloadTable[1] = fileContent

  sendMessage(to, "file_transfer", payloadTable)
  sleep(0.5)
end

function receiveMessage()
  setup()
  local keyfile = getKeyfile()
  local id, recMsg, prot = rednet.receive()
  local pcallSuccess, decrMsg = pcall(aes.decrypt, keyfile, recMsg)

  if pcallSuccess and decrMsg ~= nil then
    local recTable = textutils.unserialize(decrMsg)

    local from = recTable[0]
    local to = recTable[1]
    local what = recTable[2]
    local payload = recTable[3]

    if to == ownLabel or to == "all" then
      if what == "file_transfer" then
        basic.writeToFile(payload[0], payload[1])
        return "event: file transfer received"
      elseif what == "log" then
        basic.appendToFileNl(payload[0], payload[1])
        return payload[1]
      elseif what == "execute_script" then
        shell.run(payload)
        return
      elseif what == "payload" then
        return payload
      end

      return recTable
    end
  else
    return "event: unencrypted message"
  end
end

return {
  sendMessage = sendMessage,
  sendFile = sendFile,
  sendLog = sendLog,
  receiveMessage = receiveMessage,
}














